Package org.apache.commons.math3.distribution

# Class ChiSquaredDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractRealDistribution
org.apache.commons.math3.distribution.ChiSquaredDistribution

All Implemented Interfaces:
  `Serializable`, `RealDistribution`

public class ChiSquaredDistribution extends AbstractRealDistribution
Implementation of the chi-squared distribution.

See Also:
  - Chi-squared distribution (Wikipedia)
  - Chi-squared Distribution (MathWorld)
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final double`
`DEFAULT_INVERSE_ABSOLUTE_ACCURACY`
Default inverse cumulative probability accuracy

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

## Constructor Summary

Constructors
Constructor
Description
`ChiSquaredDistribution(double degreesOfFreedom)`
Create a Chi-Squared distribution with the given degrees of freedom.
`ChiSquaredDistribution(double degreesOfFreedom, double inverseCumAccuracy)`
Create a Chi-Squared distribution with the given degrees of freedom and inverse cumulative probability accuracy.
`ChiSquaredDistribution(RandomGenerator rng, double degreesOfFreedom)`
Create a Chi-Squared distribution with the given degrees of freedom.
`ChiSquaredDistribution(RandomGenerator rng, double degreesOfFreedom, double inverseCumAccuracy)`
Create a Chi-Squared distribution with the given degrees of freedom and inverse cumulative probability accuracy.

## Method Summary

Modifier and Type
Method
Description
`double`
`cumulativeProbability(double x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`density(double x)`
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`getDegreesOfFreedom()`
Access the number of degrees of freedom.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`protected double`
`getSolverAbsoluteAccuracy()`
Returns the solver absolute accuracy for inverse cumulative computation.
`double`
`getSupportLowerBound()`
Access the lower bound of the support.
`double`
`getSupportUpperBound()`
Access the upper bound of the support.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`boolean`
`isSupportLowerBoundInclusive()`
Whether or not the lower bound of support is in the domain of the density function.
`boolean`
`isSupportUpperBoundInclusive()`
Whether or not the upper bound of support is in the domain of the density function.
`double`
`logDensity(double x)`
Returns the natural logarithm of the probability density function (PDF) of this distribution evaluated at the specified point `x`.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, inverseCumulativeProbability, probability, probability, reseedRandomGenerator, sample, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY
Default inverse cumulative probability accuracy

Since:
  2.1
See Also:
  - Constant Field Values

## Constructor Details

### ChiSquaredDistribution

public ChiSquaredDistribution(double degreesOfFreedom)
Create a Chi-Squared distribution with the given degrees of freedom.

Parameters:
  `degreesOfFreedom` - Degrees of freedom.

### ChiSquaredDistribution

public ChiSquaredDistribution(double degreesOfFreedom, double inverseCumAccuracy)
Create a Chi-Squared distribution with the given degrees of freedom and inverse cumulative probability accuracy.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `AbstractRealDistribution.sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `degreesOfFreedom` - Degrees of freedom.
  `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Since:
  2.1

### ChiSquaredDistribution

public ChiSquaredDistribution(RandomGenerator rng, double degreesOfFreedom)
Create a Chi-Squared distribution with the given degrees of freedom.

Parameters:
  `rng` - Random number generator.
  `degreesOfFreedom` - Degrees of freedom.
Since:
  3.3

### ChiSquaredDistribution

public ChiSquaredDistribution(RandomGenerator rng, double degreesOfFreedom, double inverseCumAccuracy)
Create a Chi-Squared distribution with the given degrees of freedom and inverse cumulative probability accuracy.

Parameters:
  `rng` - Random number generator.
  `degreesOfFreedom` - Degrees of freedom.
  `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Since:
  3.1

## Method Details

### getDegreesOfFreedom

public double getDegreesOfFreedom()
Access the number of degrees of freedom.

Returns:
  the degrees of freedom.

### density

public double density(double x)
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

### logDensity

public double logDensity(double x)
Returns the natural logarithm of the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient. Note that due to the floating point precision and under/overflow issues, this method will for some distributions be more precise and faster than computing the logarithm of `RealDistribution.density(double)`. The default implementation simply computes the logarithm of `density(x)`.

Overrides:
  `logDensity` in class `AbstractRealDistribution`
Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the logarithm of the value of the probability density function at point `x`

### cumulativeProbability

public double cumulativeProbability(double x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### getSolverAbsoluteAccuracy

protected double getSolverAbsoluteAccuracy()
Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the maximum absolute error in inverse cumulative probability estimates

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution. For `k` degrees of freedom, the mean is `k`.

Returns:
  the mean or `Double.NaN` if it is not defined

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution.

Returns:
  `2 * k`, where `k` is the number of degrees of freedom.

### getSupportLowerBound

public double getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) > 0}`.

The lower bound of the support is always 0 no matter the degrees of freedom.

Returns:
  zero.

### getSupportUpperBound

public double getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

The upper bound of the support is always positive infinity no matter the degrees of freedom.

Returns:
  `Double.POSITIVE_INFINITY`.

### isSupportLowerBoundInclusive

public boolean isSupportLowerBoundInclusive()
Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

public boolean isSupportUpperBoundInclusive()
Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`